

function love.load()
	map = {}
	map[1] = 1
end

mouseX = 0
mouseY = 0
lmouseY = 0 -- last mouse y
lmouseX = 0

function love.update(dt)
	mouseX = love.mouse.getX()
	mouseY = love.mouse.getY()
	if(love.mouse.isDown("r")) then
		local dy = mouseX - lmouseX
		cam.y = cam.y + mouseY - lmouseY
	end
	
	if(love.keyboard.isDown("w")) then
		cam.y = cam.y + 100 * dt
	elseif(love.keyboard.isDown("s")) then
		cam.y = cam.y - 100 * dt
	end
	
	lmouseX = mouseX
	lmouseY = mouseY
end

function love.mousepressed(x,y,button)
	if(button == "l") then
		for i=1,#map do
			if(mouseCol(0,i*tileSize,tileSize,tileSize,x,y - cam.y)) then
				map[i] = map[i] + 1
				if(map[i] > 3) then
					map[i] = 1
				end
			end
			
			if(mouseCol(tileSize + 10,i*tileSize,tileSize,tileSize,x,y - cam.y)) then
				map[i] = 1
			end
			if(mouseCol(tileSize*2 + 30,i*tileSize,tileSize,tileSize,x,y - cam.y)) then
				map[i] = 2
			end
			if(mouseCol(tileSize*3 + 50,i*tileSize,tileSize,tileSize,x,y - cam.y)) then
				map[i] = 3
			end
			if(mouseCol(tileSize*5 + 90,i*tileSize,tileSize,tileSize,x,y - cam.y)) then
				map[i] = 0
			end
			if(mouseCol(tileSize*6 + 110,i*tileSize,tileSize,tileSize,x,y - cam.y)) then
				map[i] = 4
			end
		end

		if(mouseCol(0,#map*tileSize + tileSize,tileSize,tileSize,x,y - cam.y)) then
			map[#map+1] = map[#map]
		end
	end
	
	if(button == "wu" and tileSize > 10) then
		tileSize = tileSize - 5
	end
	if(button == "wd") then
		tileSize = tileSize + 5
	end
end

tileSize = 20

render = 50
cam = {}
cam.x = 0
cam.y = 1
function love.draw()
	love.graphics.push()
	love.graphics.translate(cam.x,cam.y)

	local ty = math.floor(-cam.y/tileSize)
	for i=ty - render,ty + render do
		if(i >= 1 and i <= #map) then
			if(map[i] == 1) then
				love.graphics.setColor(255,0,0)
				love.graphics.rectangle("fill",0,i*tileSize,tileSize,tileSize)
			elseif(map[i] == 2) then
				love.graphics.setColor(0,255,0)
				love.graphics.rectangle("fill",0,i*tileSize,tileSize,tileSize)
			elseif(map[i] == 3) then
				love.graphics.setColor(0,0,255)
				love.graphics.rectangle("fill",0,i*tileSize,tileSize,tileSize)
			elseif(map[i] == 4) then
				love.graphics.setColor(255,255,255)
				love.graphics.rectangle("line",0,i*tileSize,tileSize,tileSize)
			end
			love.graphics.setColor(255,255,255)
			
			love.graphics.rectangle("line",tileSize + 10,i*tileSize,tileSize,tileSize)
			love.graphics.rectangle("line",tileSize*2 + 30,i*tileSize,tileSize,tileSize)
			love.graphics.rectangle("line",tileSize*3 + 50,i*tileSize,tileSize,tileSize)
			love.graphics.rectangle("line",tileSize*5 + 90,i*tileSize,tileSize,tileSize)
			love.graphics.rectangle("line",tileSize*6 + 110,i*tileSize,tileSize,tileSize)
			
			love.graphics.print(i,tileSize*4 + 70,i*tileSize + 2)
		end
	end
	love.graphics.rectangle("line",0,#map*tileSize + tileSize,tileSize,tileSize)
	love.graphics.pop()
end

function mouseCol(x1,y1,w,h,mx,my)
	if(mx > x1 and mx < x1 + w and my > y1 and my < y1 + h) then
		return true
	end
end


function love.keypressed(key)
	if(key == "k") then
		save()
	end
	if(key == "l") then
		load()
	end
end

filename = "save.lua"
tosave = ""
function save()
	tosave = ""
	tosave = "map = {"
	for i=1,#map do
		if(i == #map) then
			tosave = tosave..map[i]
		else
			tosave = tosave..map[i]..","
		end
	end
	tosave = tosave.."}"
	
	love.filesystem.write(filename,tosave)
	
	tosave = ""
end

toload = ""
function load()
	toload = love.filesystem.load(filename)
	toload()
	toload = ""
end